%                        Fig10_3.m 
%
%               Rotor bearing system (Figure 9.12 & Table 9.8)
% 
%         Figure 10.3 - contains unbalance response of the rotor bearing 
%                       system (Figure 9.12); 
%                      (a) responses in the two transverse directions 
%                          (dofs 41, 42) at the bearing location at node 11
%                      (b) responses in the two transverse directions 
%                          (dofs 57, 58) at the bearing location at node 15
%
%__________________________________________________________________________   
clc
clear all
close all
%
%
% reference values of the rotor-bearing parameters
 byy=4.378*10^7;
 bzz=4.378*10^7;
 cyy=2.627e3;
 czz=2.627e3;
%
%
%
% frequency bandwidth
fr=(500:1:2500);
% to obtain frequency (unbalance) response
[z]=rotor_states_full_model(byy,bzz,cyy,czz);
%
%
figure(1)   % plots at dof - 41 and 42  (node 11) - Figure 10.3a
plot(fr,z(1,:),'black'),hold on
plot(fr,z(2,:),'--black')
figure(2)       % plots at dof - 57 and 58 (node 15)-   Figure 10.3b
plot(fr,z(3,:),'black'),hold on
plot(fr,z(4,:),'--black')
% 
%
