%                   ENKF_blend_egt_opt.m
%
%               computes the additive gain term for update
%
%                    calls gain_matrix.m
%__________________________________________________________________________
function [x2] = ENKF_blend_egt_opt(x1,Np,D,weights,r1_st,r2_st,r3_st,CR2,cost)

CR1 = 0.1;
%__________________________________________________________________________
h0 = (x1(:,r2_st) - x1(:,r3_st));   % coalescence option
min_cost=min(cost);
hf=cost(r2_st)'-min_cost;           % greedy search
h=[hf;h0];
%--------------------------------------------------------------------------
gain = gain_matrix(x1,h,Np);
innv = gain*h;

for i = 1:Np
    j = randi(D);
    for k = 1:D
        temp = x1(j,r1_st(i)) + innv(j,i);
        if rand < CR1 || (k == D)   % for update
            trial(j,1) = temp;
            if(trial(j,1)<0.004 || trial(j,1)>0.05)   % constraints in diameters
                trial(j,1) = x1(j,i);
            end
        elseif rand < CR2   % for blending option
            trial(j,1) = weights(i)*x1(j,i) + (1 - weights(i))*temp;
             if(trial(j,1)<0.004 || trial(j,1)>0.05)    % constraints in diameters
                trial(j,1) = x1(j,i);
            end
        else
            trial(j,1) = x1(j,i);
        end
        
        j = mod(j+1,D);
        if j == 0
            j = D;
        end
    end
    
    x2(:,i) = trial;
    
end