%               called by Rotor_unbalance_response.m
%
%           output the stiffness, mass and damping matrics
%
%__________________________________________________________________________
function [amt,amr,akb,ag]=rotor_matrices(nodes,nel,sl,sm,sa,se,si,dens,xmiy)

	
	amt=zeros(8,8);
    amr=zeros(8,8);

    akb=zeros(8,8);

     ag=zeros(8,8);
   

	C1 = sm*sl/420;
	C2 = sm*sa*sa/(120*sl);
	C4 = se*si/(sl*sl*sl);

	E1 = 4.0 * sl*sl;
	E2 = 3.0 * sl*sl;
	E3 = 22.0 * sl;
	E4 = 13.0 *sl;

      amt(1,1) = 156.0;
      amt(2,2) = 156.0;
      amt(3,2) = -E3;
      amt(3,3) = E1;
      amt(4,1) = E3;
      amt(4,4) = E1;
      amt(5,1) = 54;
      amt(5,4) = E4;
      amt(5,5) = 156.0;
      amt(6,2) = 54.0;
      amt(6,3) = -E4;
      amt(6,6) = 156.0;
      amt(7,2) = E4;
      amt(7,3) = -E2;
      amt(7,6) = E3;
      amt(7,7) = E1;
      amt(8,1) = -E4;
      amt(8,4) = -E2;
      amt(8,5) = -E3;
      amt(8,8) = E1;

	E1 = 4.0 * sl*sl;
	E2 =  sl*sl;
	E3 = 3 * sl;

      amr(1,1) = 36.0;
      amr(2,2) = 36.0;
      amr(3,2) = -E3;
      amr(3,3) = E1;
      amr(4,1) = E3;
      amr(4,4) = E1;
      amr(5,1) = -36;
      amr(5,4) = -E3;
      amr(5,5) = 36.0;
      amr(6,2) = -36.0;
      amr(6,3) = E3;
      amr(6,6) = 36.0;
      amr(7,2) = -E3;
      amr(7,3) = -E2;
      amr(7,6) = E3;
      amr(7,7) = E1;
      amr(8,1) = E3;
      amr(8,4) = -E2;
      amr(8,5) = -E3;
      amr(8,8) = E1;

      RHO = dens;
      COEFG = RHO*xmiy/sl;

      ag(2,1)  =  COEFG*2.4;
      ag(3,1)  = -COEFG*sl*0.2;
      ag(6,1)  = -ag(2,1);
      ag(5,2)  = -ag(6,1);
      ag(6,5)  =  ag(2,1);
      ag(7,1) = -COEFG*sl*0.2;
      ag(4,2)  =  ag(3,1);
      ag(5,3)  =  ag(3,1);
      ag(6,4)  =  ag(3,1);
      ag(8,2) =  ag(7,1);
      ag(7,5) = -ag(7,1);
      ag(8,6) = -ag(7,1);
      ag(4,3)  =  COEFG*sl*sl/3.75;
      ag(8,3) = -COEFG*sl*sl/15.0;
      ag(7,4) = -ag(8,3);
      ag(8,7)=  ag(4,3);

	E1 = 4.0 * sl*sl;
	E2 = 2.0 * sl*sl;
	E3 = 6.0 * sl;

      akb(1,1) = 12.0;
      akb(2,2) = 12.0;
      akb(3,2) = -E3;
      akb(3,3) = E1;
      akb(4,1) = E3;
      akb(4,4) = E1;
      akb(5,1) = -12;
      akb(5,4) = -E3;
      akb(5,5) = 12.0;
      akb(6,2) = -12.0;
      akb(6,3) = E3;
      akb(6,6) = 12.0;
      akb(7,2) = -E3;
      akb(7,3) = E2;
      akb(7,6) = E3;
      akb(7,7) = E1;
      akb(8,1) = E3;
      akb(8,4) = E2;
      akb(8,5) = -E3;
      akb(8,8) = E1;

	for i=1:8
	for j=1:8
      if(j>i)
	amt(i,j) = amt(j,i);        % mass matrix (symmetric)
	amr(i,j) = amr(j,i);        % mass matrix (symmetric)
	ag(i,j)  = -ag(j,i);        % gyroscopic (damping) matrix (skew-symetric)
	akb(i,j) = akb(j,i);        % stiffness matrix (symmetric)
      end
    end
    end

	for i=1:8
	for j=1:8
	amt(i,j) = amt(i,j) * C1;                
	amr(i,j) = amr(i,j) * C2;              
	akb(i,j) = akb(i,j) * C4;               
    end
    end

   