function [x2] = ENKF_blend_opt(x1,Np,D)

CR1 = 0.1;
CR2 = 0.1;
%
alpha = 0.8;

for i = 1:Np
    r1 = i;
    while r1 == i
        r1 = randi(Np);
    end
    r1_st(i) = r1;
    r2 = i;
    while (r2 == r1 || r2 == i)
        r2 = randi(Np);
    end
    r2_st(i) = r2;
    r3 = i;
    while (r3 == r1 || r3 == r2 || r3 == i)
        r3 = randi(Np);
    end
    r3_st(i) = r3;
end

h = (x1(:,r2_st) - x1(:,r3_st));
gain = gain_matrix(x1,h,Np);
innv = gain*h;

for i = 1:Np    % scrambling loop over the particles
%   
    j = randi(D);
%  
    for k = 1:D   % scrambling loop over the parameters  ( Equation 10. )
%       
        temp = x1(j,r1_st(i)) - innv(j,i);
%    
        if rand < CR1 || k == D
            trial(j,1) = temp;
%--------------------------------------------------------------------------            
        elseif rand < CR2
            trial(j,1) = alpha*x1(j,i) + (1 - alpha)*temp;   % blending previous x1(j,i) and 
%                                                                the updated particle with probability  
%--------------------------------------------------------------------------
%                                                                                                                                  
%                                             
        else
            trial(j,1) = x1(j,i);
        end
%        
        j = mod(j+1,D);
%        
        if j == 0
            j = D;
        end
%       
    end   % end of scrambling loop over the parameters
    
    x2(:,i) = trial;
    
end                 %  end of the scrambling loop over the particles