%       called by Table10_2_COMBEOandDE.m
%
%        result by COMBEO (Table 10.1)
%__________________________________________________________________________
function [x2] = ENKF_opt(x1,Np,D)
%
CR = 0.1;
%
for i = 1:Np
    r1 = i;
    while r1 == i
        r1 = randi(Np);
    end
    r1_st(i) = r1;
    r2 = i;
    while (r2 == r1 || r2 == i)
        r2 = randi(Np);
    end
    r2_st(i) = r2;
    r3 = i;
    while (r3 == r1 || r3 == r2 || r3 == i)
        r3 = randi(Np);
    end
    r3_st(i) = r3;
end
%
h = (x1(:,r2_st) - x1(:,r3_st));
gain = gain_matrix(x1,h,Np);
innv = gain*h;
%
for i = 1:Np             % scrambling loop over the particles 
    j = randi(D);
%    
    for k = 1:D            % scrambling loop over the parameters  ( Equation 10. )
%        
        if rand(1) < CR || k == D
            trial(j,1) = x1(j,r1_st(i)) - innv(j,i);
        else
            trial(j,1) = x1(j,i);
        end
        
        j = mod(j+1,D);
        if j == 0
            j = D;
        end
    end              % end of scrambling loop over the parameters
%    
    x2(:,i) = trial;
%    
end         %  end of the scrambling loop over the particles