%                   Table10_4_DiEv.m
%
%    This program runs for DiEv algorithm
%
%                        
%
% NOTE:  (Since it is a stochastic search) try repeated MC runs > 1 for a positive result 
%__________________________________________________________________________
close all;
clear all;
clc;
%
%
%
%
nx = 40;   % dimensionality of benchmark functions 1000
ne = 10;   % population size (For F6 change to 50 and to 100 for F11)
%
%
Max_FEs = 4*1e6*ne      % maximal number of FEs, should be set to 3e+06
%
stopfitness = 1e-5;      % stop if fitness < stopfitness (minimization)
%
global initial_flag;    % the global flag used in test suite
initial_flag = 0;       % should set the flag to 0 for each run, each function
%
%--------------------------------------------------------------------------
func_num = 7;   % Enter the objective function  ( to be changed from 1 to 20)
%
%--------------------------------------------------------------------------
%
%
% set the lower and upper bound for each function
if (func_num == 1 || func_num == 4 || func_num == 7 || func_num == 8 || func_num == 9 || func_num == 12 || func_num == 13 || func_num == 14 || func_num == 17 || func_num == 18 || func_num == 19 || func_num == 20)
    lb = -100;
    ub = 100;
end
if (func_num == 2 || func_num == 5 || func_num == 10 || func_num == 15)
    lb = -5;
    ub = 5;
end
if (func_num == 3 || func_num == 6 || func_num == 11 || func_num == 16)
    lb = -32;
    ub = 32;
end
%
%
pop = lb + (ub - lb)*rand(nx,ne);                % initial population
val = benchmark_func(pop',func_num);             % fitness evaluation
% 
%
%
FEs = ne;                                       % count the number of function evaluations
%
tic;
icount=0;
while (FEs <= Max_FEs-ne)
    icount=icount+1;
    % random search, you should add your own method
%   
        newpop = DE_opt(pop,ne,nx);     %  for result by DE
%     
%    
    newval = benchmark_func(newpop', func_num);
    FEs = FEs + ne;
    index = (newval < val);
%    
    val(index) = newval(index);
    pop(:,index) = newpop(:,index);
%    
    min_val = min(val);
    mean_val = mean(val);
    count = FEs/ne;
%    
    % demo output, you should save your results to some files
    fprintf(1, 'FEs = %d, Iterations = %d: mean(val) = %f \n\n', FEs, count, mean_val);
%    
    mv(count) = mean(val);
%    
    % Break, if fitness is good enough
    if mean_val <= stopfitness
        break;
    end
%    
end
toc;
mean(newpop,2)';