%                       Table10_6.m
%
%                        COMBEO-3S scheme
%
% NOTE:  (Since it is a stochastic search) try repeated MC runs > 1 for a positive result 
%__________________________________________________________________________
close all;
clear all;
clc;
%
%   
%--------------------------------------------------------------------------
%   change the Functions here -  from  1 to 20 
func_num = 20;           % the objective function  
%--------------------------------------------------------------------------
%
nx = 40;                 % dimensionality of benchmark functions 1000
ne = 20;                 % population size
Max_FEs = 10e3*nx^2;     % maximal number of FEs, should be set to 3e+06
stopfitness = 1e-5;      % stop if fitness < stopfitness (minimization)
%--------------------------------------------------------------------------
%
nset = 4;  
%
%--------------------------------------------------------------------------
setsize = nx/nset;

global initial_flag;     % the global flag used in test suite
initial_flag = 0;        % should set the flag to 0 for each run, each function

% set the lower and upper bound for each function
if (func_num == 1 || func_num == 4 || func_num == 7 || func_num == 8 || func_num == 9 || func_num == 12 || func_num == 13 || func_num == 14 || func_num == 17 || func_num == 18 || func_num == 19 || func_num == 20)
    lb = -100;
    ub = 100;
end
if (func_num == 2 || func_num == 5 || func_num == 10 || func_num == 15)
    lb = -5;
    ub = 5;
end
if (func_num == 3 || func_num == 6 || func_num == 11 || func_num == 16)
    lb = -32;
    ub = 32;
end

pop = lb + (ub - lb)*rand(nx,ne);                % initial population
val = benchmark_func(pop',func_num);             % fitness evaluation

FEs = ne;                                       % count the number of function evaluations
count = 1;
weights = 1/ne*ones(1,ne);
r1_st = zeros(ne,1);
r2_st = zeros(ne,1);
r3_st = zeros(ne,1);

tic;

while (FEs <= Max_FEs-ne)
    
    for i = 1:ne
        r1 = i;
        while r1 == i
            r1 = randi(ne);
        end
        r1_st(i) = r1;
        r2 = i;
        while (r2 == r1 || r2 == i)
            r2 = randi(ne);
        end
        r2_st(i) = r2;
        r3 = i;
        while (r3 == r1 || r3 == r2 || r3 == i)
            r3 = randi(ne);
        end
        r3_st(i) = r3;
    end
    
    % random search
        newpop = pop;
        for ii = 1:nset
            CR2 = 0.1;
%             CR2 = rand;   %   (optional) uncomment if required
            newpoptemp = ENKF_blend_egt_opt(pop((ii - 1)*setsize + 1:ii*setsize,:),ne,setsize,weights,r1_st,r2_st,r3_st,CR2,ii);
            newpop((ii - 1)*setsize + 1:ii*setsize,:) = newpoptemp;
            newval = benchmark_func(newpop', func_num);
            index = (newval < val);
            val(index) = newval(index);
            pop(:,index) = newpop(:,index);
            weights = sum(val'.*weights) - (val'.*weights);
            weights = weights/sum(weights);
        end
%     end
%     
    min_val = min(val);
    FEs = FEs + ne;
    count = count + 1;
    
    % demo output, you should save your results to some files
    fprintf(1, 'FEs = %d, Iterations = %d: min(val) = %f \n\n', FEs, count, min_val);
    
    mv(count) = mean(val);
    
    % Break, if fitness is good enough
    if min_val <= stopfitness
        break;
    end
    
end
toc;
mean(newpop,2)';