%                       Example2_11_Fig2_14.m
%
%       MC simulation with Antithetic variables - Example 2.11
%
%    Ist run:     Standard simulation using uniform distribution
%    II nd run:   Simulation using anthithetic variables
%
%                   Figure 2.14a & b
%____________________________________________________________________
%
clc
clear all
close all
%
%
%
Nruns=10            % no. of independent MC runs  
n=1000;             % no. of samples in each MC run 
%
% --------------------------------------------------------------------
% Ist Run - Standard MC simulation  --  using uniform distribution
%
%  by change of variable x=8u-4, the integral in Example 2.11 is written
%     in terms of U - a uniformly distributed RV variable 
%           between limits [0,1] 
%                       
%
for k=1:Nruns 
 k                  
 numb(k)=k;                % MC run counter 
U=zeros(2*n,1);     
Y=zeros(2*n,1);
cnst=8;
 for i=1:2*n
     U(i)=8*rand-4;       % a uniformly distributed RV  
ax=U(i)^2-1;
if ax<0
    ax=-ax;
end
%
%               (Integrand in Example 4.11)
 Y(i)=cnst*exp(-U(i)^2)/sqrt(ax+0.01);
 end
 mean(Y)
 std(Y)*std(Y)
 m(k)=mean(Y);
  var(k)=std(Y)*std(Y);
end
%
%
%
% 
%-------------------------------------------------------------------
% 2nd Run - MC simulation with Anithetic variables
% by change of variable x=8u-4, the integral in Example 2.11 is written
%     in terms of u - a uniformly distributed RV variable 
%           between limits [0,1] 
%                 v =1-u, again a uniformly distributed RV variable 
%                         between limits [0,1] 
%
cnst=8;
for k=1:10
 k 
 numb(k)=k;              % MC run counter 
 %
u=zeros(n,1);
v=zeros(n,1);
Y=zeros(n,1);
%
for i=1:n
u(i)=8*rand-4; % a uniformly distributed RV
 v(i)=1-u(i);       % AGAIN a uniformly distributed RV
%
 ax1=u(i)^2-1;
if ax1<0
    ax1=-ax1;
end
ax2=v(i)^2-1;
if ax2<0
    ax2=-ax2;
end
 %                      (Integrand in Example 4.11)
 Y(i)=0.5*cnst*(exp(-u(i)^2)/sqrt(ax1+0.01)+exp(-v(i)^2)/sqrt(ax2+0.01));
%
 end
 mNew(k)=mean(Y)
 std(Y)*std(Y)
 varNew(k)=std(Y)*std(Y);
end 
%
%Plotting the results
figure(1)                   % Figure 4.14a
plot(numb,m,'+black','MarkerSize',10),hold on   % by standard simulation
plot(numb,mNew,'*black','MarkerSize',10)       %   by antithetic variables

figure(2)                   % Figure 4.14b
plot(numb,var,'+black','MarkerSize',10),hold on  % by standard simulation
plot(numb,varNew,'*black','MarkerSize',10)      %   by antithetic variables
%  