%                           Example2_12_Fig2_16a.m
%
%                    Important sampling and Variance reduction
%                               -  Example 2.12
%
%              plots of g(x)f(x),  f(x)   &   h(x)
%_________________________________________________________________________
clc
clear all
close all
%
pi=3.14159265;
cnst=sqrt(2*pi);
%
n=101;         %  no. of x- variable for plottng pdfs f(x) & h(x) 
                              %  plotted for -6 <= x <= +6
%
%
%---------------------------------------------------------------------
%  plots of f(x) with mu=0    &      h(x) with mu=2    &     g(x)f(x)
%
dx=0.12;     % since n=101 points nd range of x = 12
%
mu1=2;      % h(x) with mean =2
mu2=sqrt(8);   % h(x) with mean =sqrt(8)
%
for i=1:n
  x(i)=-6 + (i-1)*dx;     % x - variable
  normal1(i)=(1/cnst)*exp(-x(i)*x(i)/2);          % f(x)
  %
  normal2(i)=(1/cnst)*exp(-(x(i)-mu1)*(x(i)-mu1)/2); % h(x) with mean=2
  %
  normal3(i)=(1/cnst)*exp(-(x(i)-mu2)*(x(i)-mu2)/2);  % h(x) with mean=sqrt(8)
  %
  if(x(i)>=2)    % because of the Indicator function 
    a1=x(i)*x(i)*x(i)*x(i);
    b1=exp(x(i)*x(i)/4);
    c1=exp(-0.5*x(i)*x(i))/cnst;
    gxfx(i)=a1*b1*c1;                    % g(x)f(x)
else
    gxfx(i)=0.0;
end
end
%
%---------------------------------------------------------------
% plotting f(x),h(x) & g(x)f(x)
figure(1)
plot(x,normal1,'--black')    % f(x)
hold
plot(x,normal2,':black')    % h(x) with mean = 2
plot(x,normal3,'-.black')    % h(x) with mean = sqrt(8)
plot(x,gxfx,'black')        % g(x)f(x)

