%                           Example2_12_Fig2_16b.m
%
%                    Important sampling and Variance reduction
%                               -  Example 2.12
%
%       Comparison of variance reduction with mu = 2 & sqrt(8)
%_________________________________________________________________________
clc
clear all
close all
%
Nruns =10;     % no. of independent MC runs
n=20001;      % no. of samples in each MC run
%
pi=3.14159265;
cnst=sqrt(2*pi);
%
%-------------------------------------------------------------------------
% start of I run with mu=2 for h(x)
for j=1:Nruns
  j   %  Mc run counter
for i=1:n
%  generation of normal RV by Box-Muller method
  u1(i)=rand;
  u2(i)=rand;
  R(i)=sqrt(-2*log(u1(i)));
  Th(i)=2*pi*u2(i);
end
%
for i=1:n
  X(i)=R(i)*cos(Th(i));    % normal RV with zero mean
  Y(i)=X(i);     % This is for the sake of IInd run
end
%
mu=2;   %  important sampling density h(x)- Normal with mean =2
for i=1:n
 X(i)=X(i)+mu;   % 
end
%
sumgx=0.0;
for i=1:n
  if(X(i)>=2)   % because of the Indicator function
%
  a1=X(i)*X(i)*X(i)*X(i);
  b1=exp(X(i)*X(i)/4);
  c1=exp(-mu*X(i)+mu*mu/2);
  gxfxbyhx1(i)=a1*b1*c1;     %  gxfxbyhx1=g(x)f(x)/h(x) with mean =2
  else
      gxfxbyhx1(i)=0;
  end
end
ansi1(j)=mean(gxfxbyhx1); 
vargx=var(gxfxbyhx1);
sig1(j)=sqrt(vargx);    % standard deviation with h(x) with mean =2
%  End of 1st run  
%--------------------------------------------------------------------
%
% II run with important sampling density h(x) with mu=sqrt(8)
mu=sqrt(8);
for i=1:n
 X(i)=Y(i)+mu;
end
%
for i=1:n
  if(X(i)>=2)      % because of the Indicator function
%
  a1=X(i)*X(i)*X(i)*X(i);
  b1=exp(X(i)*X(i)/4);
  c1=exp(-mu*X(i)+mu*mu/2);
  gxfxbyhx2(i)=a1*b1*c1;    %  gxfxbyhx2=g(x)f(x)/h(x) with mean =sqrt(8)
  else
      gxfxbyhx2(i)=0;
  end
end
%
ansi2(j)=mean(gxfxbyhx2);
vargx=var(gxfxbyhx2);
sig2(j)=sqrt(vargx);  % standard deviation with h(x) with mean =sqrt(8)
numb(j)=j;
end
%
% end of 2nd run
%-------------------------------------------------------------------------
figure(1)     % comparison shown in Figure 2.16b
plot(numb,sig1,'+black','MarkerSize',10)  % plot of standard deviation with h(x) with mean =2
hold
plot(numb,sig2,'*black')  % plot of standard deviation with h(x) with mean =sqrt(8)


