%                       Example2_6_Fig2_9.m
%
%           MC simulation
%
%          
  %         Beta distribution by Rejection method  (Eample 2.6)
 %
%           Figure 2.9a    &   Figure 2.9b
%
%----------------------------------------------------------------------
clc
clear all
close all
%
n=50000;
%
alpha=135/64;    % alpha parameter (see Figure 2.8)
%
k=0;
for i=1:n

  u1=rand;                       % for h(x)
  u2=alpha*rand;                 % over the interval(0,alha*h(u1))
  %
  arg=20.0*u1*(1-u1)*(1-u1)*(1-u1);     %  g(x)=20x(1-x)^3
  if (u2<=arg)
      i;
      k=k+1;
      x(k)=u1;
  end
end
%
  m=length(x)
%  
%
  y1=sort(x);
%
nint=100;     % intervals for generating histogram and then pdf and CDF
%
%----------------------------------------------------------------------
% pdf & CDF generation
du=(y1(m)-y1(1))/nint;
sum=0;
for i=2:nint+1
    ny(i-1)=0;
    yend=y1(1)+(i-1)*du;
    yint(i-1)=yend-du/2;
    for j=1:m
        if((y1(j)>(yend-du)) && (y1(j)<=yend))
          ny(i-1)=ny(i-1)+1;
        end
    end
    pny(i-1)=ny(i-1)/m;
    sum=sum+pny(i-1)
    cny(i-1)=sum;    % CDF of beta distribution
%
    pny(i-1)=ny(i-1)/(m*du);    % pdf of beta distribution
end
%  -----------------------------------------------------------------------
% Plotting
figure(1)                               
plot(yint,pny,'black')        % simulated pdf in Figure 2.9a (dark line)
%
%
hold;
%
% empirical (theoritical) pdf 
for i=1:1001
  z(i)=(i-1)*0.001;
  w(i)=20*z(i)*(1-z(i))*(1-z(i))*(1-z(i));
end
%
% 
%
plot(z,w,'--black')                 % theoretical pdf in Figure 2.9a (dotted)
%
%
figure(2)                              
plot(yint,cny,'black')            % simulated CDF in Figure 2.9b (dark line)
%
hold;
%
%
% empirical CDF
for i=1:1001
  z(i)=(i-1)*0.001;
  a=z(i)*z(i);
  b=a*z(i);
  c=b*z(i);
  d=c*z(i);
  ww(i)=20*(a/2 - b + 0.75*c - 0.2*d);
end
%
plot(z,ww,'--black')           % theoretical CDF in Figure 2.9b (dotted line)
%------------------------------------------------------------------------

