%                    Fig2_2a_d.m
%
%    CLT theorem -  convergence of Uniform RV for n=1,2, 5 and 10
%_________________________________________________________________
clc;clear all;close all;
% 
%  CLT - with Uniform distribution
%
mu=0.5;             % mean value of parent Uniform distribution on [0,1]
sigu=0.2886;        % standard deviation value of parent Uniform distribution 
%
isamp=10;    % change isamp to 1,2, 5 & 10  
                        % (Figure 2.2a, 2.2b, 2.2c & 2.2d respectively)
%
numbers=1000000;
%
sumz=zeros(1,numbers);
delta=0.001;
%
for i=1:isamp
    y=rand(1,numbers);
    m=mean(y);
    stddev=std(y);
%
sumz=sumz+y;
end
%
%__________________________________________________________________________
mz=isamp*mu                    %  theoretical mean value    
sz=sqrt(isamp*sigu^2)          %  theoretical standard deviation
%
mz=mean(sumz)                  %  mean value by computation
sigz=std(sumz)                 %  standard deviatio by computation
%
%
% To prove central Limit Theorem:
Nb_bins=200;        % no. of bins (intervals for histogram generation)
%
%
%Histogram of sumz
    [n,axis_x]=hist(sumz,Nb_bins);
%
    du=axis_x(2)-axis_x(1)
%
pdf_estimate=n/(du*numbers);
figure(1)
plot(axis_x,pdf_estimate,'black');  %Figure 2.2a  or 2.2b  or  2.2c or 2.2d
if(isamp==1)
    ylim([0,1.2])
end
%
%
% To check the area under the pdf curve  
% sumP=0;
% for i=2:Nb_bins-1
%     sumP=sumP+pdf_estimate(i)*du;
% end
% sumP=sumP+0.5*pdf_estimate(1)*du+0.5*pdf_estimate(Nb_bins)*du

% % %
