%                    Fig2_2e_h.m
%
%    CLT theorem -  convergence of Rayleigh RV for n=1,2, 5 and 10
%_____________________________________________________________________
clc;clear all;close all;
n=100000;
pi=3.14159265;
delta=0.01;
RR=zeros(1,n);

isamp=10;    % change isamp to 1,2, 5 & 10  
                    % (Figure 2.2e, 2.2f, 2.2g & 2.2h respectively)
%_______________________________________________________________
%  CLT - with Rayleigh distribution
% 
 for j=1:isamp    
%
R=zeros(1,n);
for i=1:n
%
% generate UD RVs
  u1(i)=rand;
  u2(i)=rand;
%
 % Radius vector - Rayleigh distribution by inversion method
  R(i)=sqrt(-2*log(u1(i)));
end
%
mR=mean(R)                % mean value of parent Rayleigh distribution
sigR=std(R)               % standard deviation value of parent Rayleigh distribution 
%
RR=RR+R;
 end
%__________________________________________________________________________ 
mN=mR*isamp               %  theoretical mean value
sigM=sqrt(isamp*sigR*sigR)   %  theoretical standard deviation
%
mn=mean(RR)                  %  mean value by computation
sign=std(RR)                 %  standard deviation by computation
%
%
%___________________________________
% To prove central Limit Theorem:
Nb_bins=200;        % no. of bins (intervals for histogram generation)
numbers=n;
%

%
%Histogram of RR
    [n,axis_x]=hist(RR,Nb_bins);
%
    du=axis_x(2)-axis_x(1)
%
pdf_estimate=n/(du*numbers);
%
plot(axis_x,pdf_estimate,'black');  %Figure 2.2e, 2.2f, 2.2g or 2.2h
%
%
% Check the area under the pdf curve
% sumP=0;
% for i=2:Nb_bins-1
%     sumP=sumP+pdf_estimate(i)*du;
% end
% sumP=sumP+0.5*pdf_estimate(1)*du+0.5*pdf_estimate(Nb_bins)*du








