     %                        Fig2_4.m
     %
     %
     %                       MC simulation
     %
     %              Uniform RV and plot of its pdf curve
     %
     %                  Chi-square goodness of fit test   (Figure 2.4)
%-------------------------------------------------------------------------
clc
clear all
close all
%
% interval (a,b) of a uniform distribution 
b=1.0;   
a=0.0;      
%
% simulation of uniform RV & drawing histogram
%
m=10;  % independent MC runs
n=1000;
ftk=100;
%
for itr=1:m    % over 'm' independent MC runs

for i=1:n
  u(i)=a+(b-a)*rand;
end
%
mean(u)
var(u)
%
y=sort(u);
nint=10;                    % 10 bands having 100 numbers each
du=(y(n)-y(1))/nint;
%
chi=0.0;        %   Initialization for Chi-square statistic
%
for i=2:nint+1
    ny(i-1)=0;
    yend=y(1)+(i-1)*du;
    yint(i-1)=yend-du/2;
%
    for j=1:n
        if((y(j)>(yend-du)) && (y(j)<=yend))
          ny(i-1)=ny(i-1)+1;
        end
    end
%
sq=(ny(i-1)-ftk)*(ny(i-1)-ftk);
%
chi=chi+sq/ftk;
%
end
%
itrials(itr)=itr;
chistatic(itr)=chi;
%
end
%
figure(1)                % Figure 2.4
plot(itrials,chistatic,'.black')

xlabel('No. of trials')
ylabel('Chisquare static')
% 

%----------------------------------------------------------------------
