%                       Fig2_7.m
%
%                    MC simulation
%
%       Generation of Rayleigh RV via normal RVs
%                   Box-Muller method
%
%                           Figure 2.7 (a) and (b)
%----------------------------------------------------------------------
clc
clear all
close all
%
n=100000;
%
for i=1:n
%
% two uniformy distributed randomvariables
  u1(i)=rand;
%
% Radius vector - Rayleigh distribution by inverse method
  R(i)=sqrt(-2*log(u1(i)));   % this is processed below to get pdf and CDF curves
%
end
%
% Generation of simulated pdf and CDF of Rayleigh
% histogram on R
m=length(R);
y1=sort(R);
nint=100;                          % The RV divided into 100 intervals
du=(y1(m)-y1(1))/nint;
sum=0;
for i=2:nint+1
    ny(i-1)=0;
    yend=y1(1)+(i-1)*du;
    yint(i-1)=yend-du/2;
    for j=1:m
        if((y1(j)>(yend-du)) && (y1(j)<=yend))
          ny(i-1)=ny(i-1)+1;
        end
    end
    pnydx(i-1)=ny(i-1)/m;
    sum=sum+pnydx(i-1);
    cny(i-1)=sum;               % CDF of R
     pny(i-1)=ny(i-1)/(m*du);     % pdf of R
end
%
%--------------------------------------------------------------
dn=4.5/n;
vR=var(R)
for i=1:n+1
    r(i)=(i-1)*dn;
    Raylpdf(i)=r(i)*exp(-r(i)^2/2);
    RaylCDF(i)=1-exp(-r(i)^2/2);
end
%--------------------------------------------------------------
figure(1)
plot(yint,pny,'r') ,hold on             % pdf of R Figure 2.7a
%
plot(r,Raylpdf,'black'),hold off
%
figure(2)
plot(yint,cny,'r') ,hold on     % CDF of R  Figure 2.7b
%
plot(r,RaylCDF,'black'),hold off
