%                            Fig3_6.m
%
%                 Brownian motion & Reflection principle
%
%         ________________________________________________________________
%         IMPORTANT: Run the program again and again till B(t) crosses a
%                    the level equal to unity
%         ________________________________________________________________
%
%
%________________________________________________________________________
clc
close all
clear all
%
T=1;    % total time interval
N=1000;    % no. of time steps
dt=T/N;   % time step
t=0:dt:T;   % time variable
%
w1=zeros(N+1);w2=zeros(N+1);
dw(1)=sqrt(dt)*randn;
w1(1)=dw(1);
w2(1)=dw(1);
tou=0;
%
%
for k=2:N+1     % samples   
%    
    dw(k) = sqrt(dt)*randn;
    w1(k) = w1(k-1) + dw(k);
%      
    if(tou==0)                
      w2(k) = w2(k-1) + dw(k);   %   = B,   when t < stopping time
    end
%    
  if(w2(k)>1&&tou==0)  
     tou=t(k)                    %  capture the stopping time 'tou' 
%                                    %   when B crosses 1 for the first time
     kk=k;
%      w2(k)=w1(k);
  end
%  
   if(tou>0)                     %  when t > 'tou'
       w1(kk)
       w2(k)=2*w1(kk)-w1(k);      %  = 2B(tou)-B(t)  Equation 3.156
   end
%
end
%
%
figure(1)
plot(t,w1,'black'),hold on
plot(t,w2,'--black'), hold on % reflection occurs when B(t) crosses unity
                                    %  otherwise w2=w1
X(1:N+1)=1;
plot(t,X,'--black')
