%                              Appendix_D_FigD_3_modified_sums.m  
%
%    
%
%    Figure D.3 contains 1)  solution for the unconditioned X(t)
%                        2)  solution for the conditioned X(t)
%     
%   Note: Run the program three times to get the required result 
%                        in Figure D.3
%__________________________________________________________________________
% Another Note: comment the following three lines after the 1st run is over
%           so that the paths are plotted in the same Figure
clc
clear all
close all
%
%--------------------------------------------------------------------------
% parameters of Brownian motion
sigma=1.0;  % noise intensity
%
a=1;
b=3;
xzero=2.5;    % initial condition 
yzero=xzero;
%
T=10;   % total time of integration
dt=0.001;   % time step
t=0:dt:T;   % time variable t
%
% solution 
for k=1:numel(t)
    k  % time step 
  dB(k) = sqrt(dt)*randn; 
% 
    xOld(k)=xzero + sigma*dB(k);  %  % solution to the orginal SDE dX=dB
%
     exp1=exp(-(T-t(k)));
     exp3=exp(-9*(T-t(k)));
     exp5=exp(-25*(T-t(k)));
     exp7=exp(-49*(T-t(k)));
%
       xval1 = pi*(yzero-a)/(b-a);
       xval3 = 3*pi*(yzero-a)/(b-a);
       xval5 = 5*pi*(yzero-a)/(b-a);
       xval7 = 7*pi*(yzero-a)/(b-a);
             
       A=cos(xval1)*pi/(b-a)*exp1+cos(xval3)*pi/(b-a)*exp3;
       A=A+cos(xval5)*pi/(b-a)*exp5+cos(xval7)*pi/(b-a)*exp7;
       B=sin(xval1)*exp1+sin(xval3)*exp3/3;
       B=B+sin(xval5)*exp5/5+sin(xval7)*exp7/7;
       yNew(k)=yzero+sigma*dB(k)+(A/B)*dt;  % sol       
%
    yzero=yNew(k);
    xzero=xOld(k);
%
end
% plotting 
figure(1)
plot(t,xOld,'black'),hold on   % plotting X(t)
% 
figure(2)
plot(t,yNew,'black'),hold on     % plotting the conditioned X(t)
%_____________________________________________________________________________
%
%
