%                              Appendix_D_FigD_4.m  
%
%    
%
%    Figure D.4 contains 1)  solution for the unconditioned X(t)
%                        2)  solution for the conditioned X(t)
% 
%  Note: Run the program three times to get the required result 
%                        in Figure D.4
%__________________________________________________________________________
% Another Note: comment the following three lines after the 1st run is over
%           so that the paths are plotted in the same Figure
clc
clear all
close all
%
% parameters of Brownian motion
% to obtain the range - -eps to +eps
eps=1;
% 
sigma=2*sqrt(2)*eps/pi;  % noise intensity
%
%
xzero=0.1;    % initial condition 
%
%
%__________________________________________________________________________
%           
%
T=10;   % total time of integration
dt=0.001;   % time step
t=0:dt:T;   % time variable t
%
C=1;
% at starting time step - simulation of Brownian motion 
dB(1)=sqrt(dt)*randn;   % Brownian increment 
% 
%
%
% at first time step  
xold(1)=xzero + sigma*dB(1);  % solution to the orginal SDE dX=sigma*dB
% 
% 
yNew(1)=xzero+sigma*dB(1)-tan(pi*xzero/(2*eps))*dt;  % solution to the new SDE (Equation D.46)
%
%
% solution at all other time steps
for k=2:numel(t)
    k  % time step 
  dB(k) = sqrt(dt)*randn;
%   
% 
    xold(k)=xold(k-1) + sigma*dB(k);  %  % solution to the orginal SDE dX=sigma*dB
%
%
% 
yNew(k)=yNew(k-1)+sigma*dB(k)-tan(pi*yNew(k-1)/(2*eps))*dt;% solution to the new SDE (Equation D.46)
  %
end
% plotting 
figure(1)
plot(t,xold,'r'),hold on   % plotting X(t)
% 
% figure(2)
plot(t,yNew,'black'),hold on     % plotting the conditioned X(t)
%_____________________________________________________________________________
%
%
