%                            Eample4_17_Fig4_2.m
%
%
%    Example 4.17:  SDOF oscillator under white noise input (Equation 4.115)
%
%    Program for response moments by Ito's formula          
%
%    This program outputs the time histories of the moments
%            - E[X^2(t)],  E[XY], E[Y^2(t)]
%------------------------------------------------------------------------
clc
clear all
close all
%
      pi=3.14159265d0
      pi2=2*pi
%  SDOF oscillator data
      w=10.0d0    % natural frequency in rad/sec.
      eta=0.02d0    % damping
%      
% input white noise strength      
      sig=1.0d0     %  (Equation 4.115) 
%  
%  times step, total time of integration 
      dt=0.01;
      T=10.0;
      t=0:dt:T;    % time variable
      Nt=numel(t);    % totla number of time steps for integration
%  
% 
D=3; % no. of states (X^2,Y^2,XY) 
%                    
tt=linspace(0,T,Nt)'; % time variable
%
y0=zeros(D,1);    
X=zeros(D,Nt);    % Initialization
% 
X(:,1)=y0;          % zero initial condition
%
%
%
% Time integration by RK method starts
for ijk=1:numel(tt)-1
  dxdt=rk4Fig4_2(tt(ijk),X(:,ijk),dt);
  X(:,ijk+1)=dxdt;
end
%
 figure(1)
 plot(t,X(1,:),'black');  % Plot results for E[X^2]   Figure 4.2a
%
 figure(2)
 plot(t,X(2,:),'black');  % Plot results for E[XY]    Figure 4.2b
 %
 figure(3)
 plot(t,X(3,:),'black');  % Plot results for E[Y^2]   Figure 4.2c
%
%      steady state values of the moment E[x^2]     
       c_st=1.0/(4*eta*w);     
       a_st=c_st/(w*w)        

	