function dxdt=mySDOF4_4and5(t,q)
%
%  This program is called by rk4Fig4_4and5.m
%
% _______________________________________________________________________
%
      % input data of MDOF system (Figure 4.3)
%  damping values
      c1=5.0;
      c2=5.0;
      c3=5.0;
      c4=7.0;
% 
%stiffness values
      k1=1200.0;
      k2=1200.0;
      k3=1200.0;
      k4=3000.0;
%  
% two masses at the floor level
      m1=1;
      m2=2;
%      
% Input data of the external excitations (B1 and B2 Brownian motion) 
      sig2=1.0;
      sig4=0.5;   
%
%
% first order ODEs  Equations 4.144-153
%   
dxdt=[2*q(3);
      (1/m1)*(-2*c1*q(2)-2*k1*q(3)+2*c2*q(8)+2*k2*q(10))+sig2^2;
      q(2)+(1/m1)*(-c1*q(3)-k1*q(1)+c2*q(9)+k2*q(7));
      2*q(6);
     (1/m2)*(-2*c4*q(5)-2*k4*q(6)+2*c3*q(8)+2*k3*q(9))+sig4^2/m2^2;
      q(5)+(1/m2)*(-c4*q(6)-k4*q(4)+c3*q(10)+k3*q(7));
      q(9)+q(10);
(1/m1)*(-c1*q(8)-k1*q(9)+c2*q(5)+k2*q(6))+(1/m2)*(-c4*q(8)-k4*q(10)+c3*q(2)+k3*q(3));
      q(8)+(1/m2)*(c3*q(3)-c4*q(9)+k3*q(1)-k4*q(7));
      q(8)+(1/m1)*(-c1*q(10)+c2*q(6)-k1*q(7)+k2*q(4))]; 
      end

