%                                Example4_22_FIG4_9.m
%
%  Example 4.22:  Program for response moment E[X1^2] of an SDOF system 
%                               by Ito's formula
%
%          Compare with the response obtained by Spectral represntation 
%             approach (See Figure 4.8)
%
%           This program calls RK program namely rkFig4_9.m
%
%------------------------------------------------------------------------
%
clc
clear all
close all
%
%  time step, total time 
      dt=0.01d0;
      T=30.0;
      t=0:dt:T;
%
Nt=numel(t);    % total number of time steps for integration
%
%
D=10; % no. of states (X1^2,Y1^2,X1Y1,X^2,Y^2, X2Y2,X1Y2,Y1Y2,X1Y2 & X2Y1) 
%                    Only E[X1^2]] only is plotted in Figure 4.9

tt=linspace(0,T,Nt)'; % time variable
%
y0=zeros(D,1);    
X=zeros(D,Nt);    % Initialization
% 
X(:,1)=y0;          % zero initial condition
%
%
% Time integration by RK method starts
for ijk=1:numel(tt)-1
  dxdt=rk4Fig4_9(tt(ijk),X(:,ijk),dt);
  X(:,ijk+1)=dxdt;
end
%
 figure(1)
 plot(t,X(1,:),'black');  % Plot result only for E[X1^2]  Fgure 4.9
 %                                (compare with the result obtained, by
 %                                  spectral approach, in Figure 4.8)

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
 
    



       



	

	
  



       