function dxdt=mySDOF4_9(t,q)
%
%  This program is called by rk4Fig4_9.m
%
% _______________________________________________________________________
      pi=3.14159265d0;
      pi2=2*pi;
%
      % input data of SDOF system (Equation 4.192)
      eta=0.02d0;  % damping
      w=10.0d0;    % frequency in rad/sec.
%
%
%     Input data of the support excitation filter (Equation 4.191)  
      sig=1.0d0;   % strength of the ground motion
      etag=0.6d0;  % damping
      wg=5*pi;     % radian frequency in rad/sec.
%
%
%    Input parameters of the modulating function A(t) (Equation 4.181) 
      alpha=0.13d0;
      beta=0.45d0;
      at=sig*(exp(-alpha*t)-exp(-beta*t)); % Value of A(t) at the instant =t
%
%
% first order ODEs  Equations 4.199 to 4.208 
    dxdt=[2*q(3);
        -4*eta*w*q(2)-2*w*w*q(3)+at*4*etag*wg*q(8)+at*2*wg*wg*q(10)+4*at*at;
         q(2)-2*eta*w*q(3)-w*w*q(1)+at*2*etag*wg*q(9)+at*wg*wg*q(7);
         2*q(6);
        -4*etag*wg*q(5)-2*wg*wg*q(6)+1.0d0;
         q(5)-2*etag*wg*q(6)-wg*wg*q(4);
         q(10)+q(9);
      -q(8)*(2*eta*w+2*etag*wg)-w*w*q(9)+at*2*etag*wg*q(5)+at*wg*wg*q(6)-wg*wg*q(10)+2*at;
       q(8)-2*etag*wg*q(9)-wg*wg*q(7);
       q(8)-2*eta*w*q(10)-w*w*q(7)+at*2*etag*wg*q(6)+at*wg*wg*q(4)];

     end



	