function px=multinorm_pdf(X,Mu,CovMat)
% function to calculate multinorm pdf
% X = vector of length n (at which the pdf value is required)
% Mu= vector of mean values
% CovMat = covariance matrix n X n

n=length(X);

A=inv(CovMat);
% Coef=(2*pi)^(n/2)*sqrt(det(CovMat));
Coef=sqrt(det(A))/(2*pi)^(n/2);

s_u_m=0;
for j=1:n
    for k=1:n
        s_u_m=s_u_m+ (X(j)-Mu(j))*A(j,k)*(X(k)-Mu(k));
    end;
end;
% px=(1/Coef)*exp(-0.5*s_u_m);
px=(Coef)*exp(-0.5*s_u_m);
