% shear beam - stick model
function [K_New,C_New,phi_T_M,refk,refc,massref] =shear(m,dof)
% 6 floor building   
% clear
% close all

N=dof;      % number of floors

L=144;                   % length of each floor in in.
L=L*0.0254;              % length in m.

%m=12;                    %mass of each floor in kipssec^2/in                                       kipsec^2/sec.
m=m*175100;              % mass in kgs

E=29000;                 % in kips/sqin
E=E*1000/0.00014503773   % in N/m^2

I=3200;                  % Inertia in in^4
I=I*0.0254^4;            % in m^4

k=4*12*E*I/L^3;           % stiffness of four columns (in parallel)                                      columns in N/m

M=zeros(N,N);
for i=1:N
    M(i,i)=m;
end

K=zeros(N,N);
K(N,N)=k;
for i=1:N-1
    K(i,i)=2*k;
    if 1<i<N
     K(i,i+1)=-k;   
    end
     if 1<i<N
     K(i,i+1)=-k;
     K(i+1,i)=-k;
    end
     
end


%M=[m 0 0 0 0 0;0 m 0 0 0 0;0 0 m 0 0 0;0 0 0 m 0 0;0 0 0 0 m 0;0 0 0 0 0 m]

M=zeros(N,N);

for i=1:N
    M(i,i)=m;
end
M_original=M;

%K=[2*k -k 0 0 0 0;-k 2*k -k 0 0 0;0 -k 2*k -k 0 0;0 0 -k 2*k -k 0;0 0 0 -k 2*k -k;0 0 0 0 -k k]
K_original=K;

alpha=0.05;
beta=0.02;
C=alpha*M+beta*K;

% eigenvalues of a generalized eigenvalue problem (K-lamda^2*M)
[V,Lamda]=eigs(K,M,N);
% V is orthonormalized in Matlab

% Check for orthogonality 
Check_modal_mass=V'*M*V;
Check_eigen=V'*K*V;
% Check over

%
%Damping ratios of the 6 modes
damp=V'*C*V;
damp;
Lamda;
eta1=damp(N,N)/(2*sqrt(Lamda(N,N)));

eta2=damp(N-1,N-1)/(2*sqrt(Lamda(N-1,N-1)));

%
%
%suport excitation
% Seismic acceleration time history - for example - a half sine wave 
pi=3.14159265;

T=4.99;
dt=0.01;
t=0:dt:T;
Nt=numel(t);
Nodalforce=zeros(N,Nt);

Ex_freq=10;  % in rad/sec.
for k=1:numel(t)
    k;
  f(k)=sin(2*pi*Ex_freq*t(k));
end

% Equivalent Nodal forcs

MM=ones(1,N);%%[1 1 1 1 1 1];
phi_T_M=m*V'*MM';
for j=1:N
for k=1:numel(t)
     Nodalforce(j,k)=phi_T_M(j)*f(k);
end 
end
massref=M(1,1);    
refk=K(1,1)/2;
refc=C(1,1)/2;
K_New=K/M;
C_New=C/M;

Nodalforce_New=Nodalforce/m;

