%                           Example8_2_Fig8_9.m
%
%
%                       soluton to 2-dof oscillator 
%
%                with and without GCLM (Lower) correction 
%                   
%   Figure 8.9  - E[X1^2] - Lower order solution  + without correction
%__________________________________________________________________________
%
clc; clear all; close all;
%
tic;
%
%
% Input parameters of the 2-dof oscillator
c1=1.0;c2=1.0;k1=10;k2=10;k3=10;alpha=10;sigma1=0.5, sigma2=0.5;ome_ga=1;
%
% 
% 
NN=10000; % No of particles(Ensemble size)
%
hh=0.25  % time step
NL=40; % no. of time steps
%
Final_disp1=zeros(NN,NL);
Final_vel1=zeros(NN,NL);
Final_disp2=zeros(NN,NL);
Final_vel2=zeros(NN,NL);
% 
%
%
%__________________________________________________________________________
%                 start of solution without correction
%
for j=1:NN   
%
j     %  sample counter
%
A=[0 1 0 0; -(k1+k2) -c1 k2 0; 0 0 0 1; k2 0 -(k2+k3) -c2];
%
X=zeros(2,10);
xi(1)=0.01;
xi(2)=0.01;
xi(3)=0.01;
xi(4)=0.01;
%
Randn=zeros(1,NL);
Omega_init=0;
for l=0:NL-2      
        
        T0=l*hh;
        T=T0+hh;
       
   ta=0.5*hh*(1-1/sqrt(3));
   tb=0.5*hh*(1+1/sqrt(3));
            T_ini=T0;
            T_f=T;
            h_inter=T-T0;
 TRa=0;TRb=0;
            TRa=(((expm(A*(h_inter-ta)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
            TRb=(((expm(A*(h_inter-tb)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
            TR= 0.5*h_inter*(TRa+TRb);
            Fa=(expm(A*(h_inter-ta)))* [0; -alpha*(xi(1))^3;0;0];
            Fb=(expm(A*(h_inter-tb)))* [0; -alpha*(xi(1))^3;0;0];
            Fab= 0.5*h_inter*(Fa+Fb);
            Randn2dof=[0; randn(1); 0 ;randn(1)];
            F11=sqrt(TR)*Randn2dof;
X=(expm(A*(T-T0)))*xi'+F11+Fab;
%
xi(1)=X(1);
xi(2)=X(2);
xi(3)=X(3);
xi(4)=X(4);
% 
displ_sqr(l+2)=X(1)^2;
vel1_sqr(l+2)=X(2)^2;
disp2_sqr(l+2)=X(3)^2;
vel2_sqr(l+2)=X(4)^2;
end
Final_disp1(j,:)=displ_sqr;
Final_vel1(j,:)=vel1_sqr;
Final_disp2(j,:)=disp2_sqr;
Final_vel2(j,:)=vel2_sqr;
end
MM1=mean(Final_disp1(1:j,:));
MV1=mean(Final_vel1(1:j,:));    % not used
MM2=mean(Final_disp2(1:j,:));   % not used
MV2=mean(Final_vel2(1:j,:));    % not used
 t=hh:hh:NL*hh;
 %
  figure(11)    % E[X1^2]
  plot(t,MM1(:),'black');hold on   % displacement without correction
  %
%   figure(21)                            % not used 
%   plot(t,MV1(:),'--black');hold on      % not used
  %
  toc;
%__________________________________________________________________________
%
%
%
%
%
%               Start of solution with GCLM...LOWER ORDER CORRECTION
%               ----------------------------------------------------
tic
P=2;
hl=hh;
M=NL;%
N=NN;%
Pl=P;
Displ_l=zeros(N,Pl+2);
Vel_l=zeros(N,Pl+2);
%
X_init_l=zeros(4,N);
%
Phi_next_l=zeros(1,N);
 nn=0;
 Brow_l=zeros(1,Pl+2);
 Brow_l(1)=0;
% 
for i=1:M 
 % No of timesteps
    T0_l=(i-1)*hl;
    T_l=i*hl;
   il=i
%
    for j=1:N
%
        xi_l(1)=X_init_l(1,j);% Initial values of disp and velocity
        xi_l(2)=X_init_l(2,j);
        xi_l(3)=X_init_l(3,j);
        xi_l(4)=X_init_l(4,j);
        Phi_1_l(1)=Phi_next_l(j);
%        
        I=0;
      while (I==0)
        Sol_x_l=zeros(4,Pl+2);
        Phi_1_l=zeros(1,Pl+2);
        New_Phi_l=zeros(1,Pl+2);
% 
        Sol_x_l(1,1)=xi_l(1);
        Sol_x_l(2,1)=xi_l(2);
        Sol_x_l(3,1)=xi_l(3);
        Sol_x_l(4,1)=xi_l(4);    
%      
                T_random_l=T0_l+(T_l-T0_l)*rand(Pl,1);
                T_ascend_l=sort(T_random_l);
                T_final_l=cat(1,T0_l,T_ascend_l,T_l);
%            
        for p=2:Pl+2
%
            T_ini=T_final_l(p-1);
            T_f=T_final_l(p);
            h_inter=T_f-T_ini;
%            
            ta=0.5*h_inter*(1-1/sqrt(3));
            tb=0.5*h_inter*(1+1/sqrt(3));
%
            TRa=0;TRb=0;
            TRa=(((expm(A*(h_inter-ta)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
            TRb=(((expm(A*(h_inter-tb)))*[0  0 0 0;0 sigma1 0 0;0 0 0 0;0 0 0 sigma2]).^2);
            TR= 0.5*h_inter*(TRa+TRb);
            Fa=(expm(A*(h_inter-ta)))* [0; -alpha*(xi_l(1))^3;0;0];
            Fb=(expm(A*(h_inter-tb)))* [0; -alpha*(xi_l(1))^3;0;0];
            Fab= 0.5*h_inter*(Fa+Fb);
            Randn2dof=[0; randn(1); 0 ;randn(1)];
            F11=sqrt(TR)*Randn2dof;
            X_l=(expm(A*(T_final_l(p)-T_final_l(p-1))))*xi_l'+F11+Fab;
%            
            Biplus1_l=randn(1)*sqrt(T_final_l(p)-T_final_l(p-1));
            Brow_l(p)=Biplus1_l;
            Phi_1_l(p)=(-1/sigma1)*alpha*3*X_l(1)^2*X_l(2)*Brow_l(p) + (1/2)*(1/sigma1^2)*alpha^2*((X_l(1)^3)-(xi_l(1)^3))^2;
            xi_l(1)=X_l(1);
            xi_l(2)=X_l(2);
            xi_l(3)=X_l(3);
            xi_l(4)=X_l(4);
            Sol_x_l(1,p)=X_l(1);
            Sol_x_l(2,p)=X_l(2);
            Sol_x_l(3,p)=X_l(3);
            Sol_x_l(4,p)=X_l(4); 
%          
        end
        for ii=1:Pl+2
            if Phi_1_l(ii)<0
                New_Phi_l(ii)=Phi_1_l(ii);
            else New_Phi_l(ii)=0;
            end
        end
%
        New_Phi_sort_l=sort(New_Phi_l);
        C=abs(New_Phi_sort_l(1));
        Phi_1_l=Phi_1_l+C;
        U_l=rand(1);
        for jj=2:Pl+1           %...........taken only the 2 random pts in bet
            for kk=1:100
                W_l=(1/hl)*rand(1);

                if ((Phi_1_l(jj)<W_l)||(U_l>1/factorial(kk)))
                    if mod(kk,2)~=0;
                        if jj<Pl+1      %...........taken only  the 2 random pts in bet
                           % disp('repeat')
                            NNN=0;
                            break;
                        else I=1;
                            NNN=0;
                            Displ_l(j,:)=Sol_x_l(1,:);
                            Vel_l(j,:)=Sol_x_l(2,:);
                            X_inter_init_di1_l(:,j)=Sol_x_l(1,Pl+2);
                            X_inter_init_vel1_l(:,j)=Sol_x_l(2,Pl+2);
                            X_inter_init_di2_l(:,j)=Sol_x_l(3,Pl+2);
                            X_inter_init_vel2_l(:,j)=Sol_x_l(4,Pl+2);
                                                      
                            Weight_l(j)=exp(((-1/sigma1)*alpha*(Sol_x_l(1,Pl+2)^3*Brow_l(Pl+2)-Sol_x_l(1,Pl+1)^3*Brow_l(Pl+1)-Sol_x_l(1,Pl+1)^3*(Brow_l(Pl+2)-Brow_l(Pl+1))))-C*(T_final_l(Pl+2)-T_final_l(Pl+1)));
                          %% B_init=Biplus1;
                             Brow_l(1)=Brow_l(Pl+2);
                            New_Phi_l(j)=Phi_1_l(Pl+2);
                            Time_dur_l(j,:)=T_final_l;
                            %disp('Accepted');
                            break;
                        end
                    else I=0;NNN=1;
                        %disp('Not Accepted');
                        break;
                    end
                end
            end
           if NNN~=0 
               break;
           end
        end
      end
    end
%
X_init_prev_l=[X_inter_init_di1_l; X_inter_init_vel1_l;X_inter_init_di2_l; X_inter_init_vel2_l];
X_init_l=X_init_prev_l(:,resample(Weight_l));
%
%
Phi_next_l=New_Phi_l;
 if i<M
 FinalX_disp1(i+1)=mean(X_init_l(1,:).^2);
 FinalX_vel1(i+1)=mean(X_init_l(2,:).^2);
 FinalX_disp2(i+1)=mean(X_init_l(3,:).^2);
 FinalX_vel2(i+1)=mean(X_init_l(4,:).^2);
% 
 end
%
end
%
%
ttt=hl:hl:M*hl;
figure(11);    %   Figure 8.9 -  E[X1^2] with GCLM (lower order) correction)
plot(ttt,FinalX_disp1,'--black');hold on  %   E[X1^2] 
%
toc;