%                               Fig9_1.m
%
%      Classical method (derivative method by Davidon-Fletcher-Powell)
%                       (derivative method)
%             
%  Optimization of Rosenbrock function f(x1,x2)=100(x1^2-x2 )^2+(x1-1)^2 
%
%
%   routines called : deriv.m
%                     myfun.m
%                     func.m                  
%__________________________________________________________________________
clear all;
clc;
close all;
%
global y1 y2 dir1 dir2
%
D=2;
der=zeros(2);
%
%
% starting values  
x10=10.0;
x20=10.0;
%
x1=x10;
x2=x20;
%
x=[x1;x2];
[der]=deriv(D,x)   % find directions 
g0=der;
%
%  
icount=1;
%
 f_value(icount)=func(x);
  xx1(icount)=x(1);
   xx2(icount)=x(2);
   ic(1)=icount;
%   
   H0=eye(2,2);   % Hessian matrix (initial assumption)
%   
   d0=-H0*g0;
   tol=0.001;
%   
while norm(g0)>tol
  icount=icount+1
   ic(icount)=icount;
%   
    y1=x(1);
    y2=x(2);
%    
    dir=d0;  
%    
 dir1=dir(1);
 dir2=dir(2);
%
 % to find the step size (lamda) that locally 
 %     minimizes @myfun (see myfun.m) in the 
 %     directions given by dir1 & dir2  
lamda = fminbnd(@myfun,-100,100)% unconstrained optimization 
%
    x=x+lamda*dir  ;  
%
p0=lamda*d0;
%   
        g1=deriv(D,x) ;   
%        
        q1=g1-g0;
% 
% update the Hessian matrix
     H1=H0+ p0*p0' /(p0'*q1) - H0*q1*q1'*H0/(q1'*H0*q1);
%     
     d0=-H1*g1;
%     
     g0=g1;        
      H0=H1;
%      
%   
    f_value(icount)=func(x)
%    
   xx1(icount)=x(1)
   xx2(icount)=x(2)
end
%
fun_value=func(x)    % final optimum value for the function
%
%plottting the results
figure(1)
plot(ic,f_value,'black')       % Figure 9.1a
figure(2)
plot(ic,xx1,'black')    % Figure 9.1b
figure(3)
plot(ic,xx2,'black')    % Figure 9.1c
