
function xmin=purecmaes
 % 
 % 
clc;
clear all;
close all;
 % 
 strfitnessfct = 'felli'; % name of objective function
 N =2; % problem dimension
 xmean = randn(N,1); % initial variables
 sigma = 0.5; % step-size
 stopfitness = 1e-10; % stop when fitness is less than stopfitness 
 stopeval = 1e3*N^2; % stop after 'stopeval'  evaluations

 % parameters - selection
 lambda = 4+floor(3*log(N)) % population size
 mu = lambda/2; 
 weights = log(mu+1/2)-log(1:mu)'; 
 mu = floor(mu); % number of points for recombination
 weights = weights/sum(weights); %  weights array
 mueff=sum(weights)^2/sum(weights.^2); % effective size of mu
%
 %  parameter setting - Adaptation
 cc = (4+mueff/N) / (N+4 + 2*mueff/N); 
 cs = (mueff+2)/(N+mueff+5); %
 c1 = 2 / ((N+1.3)^2+mueff); % learning rate for rank-one update of C
 cmu = 2 * (mueff-2+1/mueff) / ((N+2)^2+2*mueff/2); % learning rate for rank-mu update
 damps = 1 + 2*max(0, sqrt((mueff-1)/(N+1))-1) + cs; % damping 

 % Initialize internal strategy parameters 
 pc = zeros(N,1); ps = zeros(N,1); %
 B = eye(N); %  coordinate system
 D = eye(N); % diagonal matrix 
 C = B*D*(B*D)'; % covariance matrix
 eigeneval = 0; 
 chiN=N^0.5*(1-1/(4*N)+1/(21*N^2)); 
 % 
 %
 %----------------------------------------------------------------------
 figure(1)
 xx1 = -3:.2:3
 xx2 = -3:.2:3
 [X1,X2] = meshgrid(xx1,xx2);
 F = mvnpdf([X1(:) X2(:)],xmean',C);
 %
F = reshape(F,length(xx2),length(xx1))
surf(xx1,xx2,F);   
pause
%    
% 
 % 
 counteval = 0;
 while counteval < stopeval
counteval
 % 
 for k=1:lambda,
   k
   arz(:,k) =zeros(2,1);
   arx(:,k) =zeros(2,1);
   arz(:,k) = randn(N,1); % standard normally distributed vector
   arx(:,k) = xmean + sigma * (B*D * arz(:,k)); % add mutation % Eq. 37
   arfitness(k) = feval(strfitnessfct, arx(:,k)); % objective function call
   counteval = counteval+1;
   x1(k)=arx(1,k);
   x2(k)=arx(2,k);
% 
 end
 % plots at the start of iterations
 if(counteval==6)
     figure(1+counteval)
     plot(x1,x2,'d')  
     xlim([-2 2])
     ylim([-2 2])
 end
%  
% 
% 
 % compute weighted mean 
 [arfitness, arindex] = sort(arfitness) ;
%  
 xmean = arx(:,arindex(1:mu))*weights ;
 zmean = arz(:,arindex(1:mu))*weights; 
%  
 %  Update evolution paths
 ps = (1-cs)*ps + (sqrt(cs*(2-cs)*mueff)) * (B * zmean); 
 hsig = norm(ps)/sqrt(1-(1-cs)^(2*counteval/lambda))/chiN < 1.4+2/(N+1);
 pc = (1-cc)*pc + hsig * sqrt(cc*(2-cc)*mueff) * (B*D*zmean); 
 % covariance matrix C
 C = (1-c1) * C ...  
+ c1 * (pc*pc' ... 
+ (1-hsig) * cc*(2-cc) * C) ;
%
 % step-size sigma
 sigma = sigma * exp((cs/damps)*(norm(ps)/chiN - 1)); % Eq. 41
%
 % Update B and D 
%  
 if counteval - eigeneval > lambda/(c1+cmu)/N/10 % to achieve O(N2)
   eigeneval = counteval;
   C=triu(C)+triu(C,1)'; % enforce symmetry
   [B,D] = eig(C); % eigen decomposition, B==normalized eigenvectors
   D = diag(sqrt(diag(D))); % D contains standard deviations now
 %
 end
 %     
 % check if fitness is good enough
 if arfitness(1) <= stopfitness
 %
 % plots at the final iteration
    figure(counteval)
    plot(x1,x2,'d') 
    xlim([-2 2])
    ylim([-2 2])
    figure(1+counteval)
    x1 = -3:.2:3; x2 = -3:.2:3;
    [X1,X2] = meshgrid(x1,x2);
    F = mvnpdf([X1(:) X2(:)],xmean',C); 
    F = reshape(F,length(x2),length(x1));
    surf(x1,x2,F);       
%    colormap hsv
% a
 break;
 end
%
 % 
 if arfitness(1) == arfitness(ceil(0.7*lambda))
   sigma = sigma * exp(0.2+cs/damps);
   disp('warning: flat fitness, consider reformulating the objective');
 end
%
 disp([num2str(counteval) ': ' num2str(arfitness(1))]);
%
 end % while, end generation loop

 % 

 disp([num2str(counteval) ': ' num2str(arfitness(1))]);
 xmin = arx(:, arindex(1));
%
%
%__________________________________________________________________________
 function f=felli(x)
     y=x';
% 
[ps D] = size(x');
% 
   f=sum(100.*(y(:,1:D-1).^2-y(:,2:D)).^2+(y(:,1:D-1)-1).^2,2);
%
