%                       Fig9_9bdf.m
%
%                   Lorenz oscillator (Equation 9.43)
%
%                     Results by PSO
%
%     This program contains only one run with Np=30
%
%         Figure 9.9b,d,f - contains results 
%                           with Np=30
%__________________________________________________________________________   
clc
clear all
close all
% 
global sigma r b
sigma = 10;
r = 28;
b = 8/3;
%
%
[z]=lorenz_states();
%
%
Np=30;Nd=3;D=3;
%
xl=-[10;10;0];xu=[51;60;40];
x1=repmat(xl,1,Np)+diag(xu-xl)*rand(D,Np);
%
%  
 x1_init=x1;
 save x2_init.mat x1_init z
% load x2_init.mat
x1=x1_init
%
%
for i=1:Np
    cost(i)=fun_chao_Lorenz(z,x1(:,i));
     P_best(:,i)=x1(:,i);
end
%
%
min_cost=min(cost);
cost_plot(1)=mean(cost);
%
x1_plot(1)=mean(x1(1,:));
x2_plot(1)=mean(x1(2,:));
x3_plot(1)=mean(x1(3,:));
%
theta_max=0.9;theta_min=0.4;
%
tic
%
%
[cost_min,G_loc]=min(cost);
G_best=P_best(:,G_loc);
v=zeros(Nd,Np);
it=1; it_max=500;
%
iteration=1:(it_max+1);
%
% plotting purposes
x1_ref(1:iteration)=10;
x2_ref(1:iteration)=28;
x3_ref(1:iteration)=8/3;
%
tic
while it<it_max
    it   % iteration counter
     theta=theta_max-(theta_max-theta_min)*(it/it_max);
    r1=rand(1);r2=rand(1);
%    
v_new=theta*v+2.0*r1*(P_best-x1)+2.0*r2*(repmat(G_best,1,Np)-x1);
%
    x_new=x1+v_new;
    for i=1:Np
%
        cost_new(i)=fun_chao_Lorenz(z,x_new(:,i));  
%        
        if cost_new(i)<=cost(i)
            P_best(:,i)=x_new(:,i);
        end
    end
 %
     [cost_new_min,G_loc]=min(cost_new);
    if (cost_new_min<=cost_min)
     G_best=x_new(:,G_loc);
     cost_min=cost_new_min;
    end
    x1=x_new;
    v=v_new;
    cost=cost_new;
%
    it=it+1;
%  
%
    cost_plot(it+1)=mean(cost);
    x1_plot(it+1)=mean(x1(1,:));
    x2_plot(it+1)=mean(x1(2,:));
    x3_plot(it+1)=mean(x1(3,:));
%
end
%
toc
iteration=1:(it_max+1);
figure(1); hold on;
plot(iteration,x1_plot,'black')    %  Figure 9_9b
plot(iteration,x1_ref,'--black')
figure(2); hold on;
plot(iteration,x2_plot,'black')     %  Figure 9_9d
plot(iteration,x2_ref,'--black')
figure(3); hold on;
plot(iteration,x3_plot,'black')     %  Figure 9_9f
plot(iteration,x3_ref,'--black')

