%                        Fig9_11bdf.m 
%
%               Chen oscillator (Equation 9.44)
%
%                  Results by PSO  (Table 9.4)
%
%  This program contains only one run with Np=30
%
%         Figure 9.11b,d,f - contains results 
%                            with Np=30
%__________________________________________________________________________ 
clc
clear all
close all
% 
global sigma r b
sigma = 35;
r = 3;
b = 28;
[z]=Chen_states();
Np=30;Nd=3;
%
sigmaL=1;sigmaU=50;
rL=-1;rU=10;
bL=1;bU=50;
%
x11=repmat(sigmaL,1,Np)+(sigmaU-sigmaL)*rand(1,Np);
x21=repmat(rL,1,Np)+(rU-rL)*rand(1,Np);
x31=repmat(bL,1,Np)+(bU-bL)*rand(1,Np);
%
%
x1=[x11;x21;x31]
%
for i=1:Np
    cost(i)=fun_chao_Chen(z,x1(:,i));
     P_best(:,i)=x1(:,i);
end
%
%
%
min_cost=min(cost);
cost_plot(1)=mean(cost);
%
x1_plot(1)=mean(x1(1,:));
x2_plot(1)=mean(x1(2,:));
x3_plot(1)=mean(x1(3,:));
%
theta_max=0.9;theta_min=0.4;
%
[cost_min,G_loc]=min(cost);
G_best=P_best(:,G_loc);
v=zeros(Nd,Np);
%
it=1; it_max=500;
%
iteration=1:(it_max+1);
%
%   reference (true) values  for plotting purposes 
x1_ref(1:iteration)=35;
x2_ref(1:iteration)=3;
x3_ref(1:iteration)=28;
%
tic
while it<it_max
    it            % iteration counter
     theta=theta_max-(theta_max-theta_min)*(it/it_max);
    r1=rand(1);r2=rand(1);
 %   
    v_new=theta*v+2.0*r1*(P_best-x1)+2.0*r2*(repmat(G_best,1,Np)-x1);
%
    x_new=x1+v_new;
    for i=1:Np
%
        cost_new(i)=fun_chao_Chen(z,x_new(:,i));  
%        
        if cost_new(i)<=cost(i)
            P_best(:,i)=x_new(:,i);
        end
    end
%
     [cost_new_min,G_loc]=min(cost_new);
    if (cost_new_min<=cost_min)
     G_best=x_new(:,G_loc);
     cost_min=cost_new_min;
    end
    x1=x_new;
    v=v_new;
    cost=cost_new;
%     
    it=it+1;
%   
%
    cost_plot(it+1)=mean(cost);
    x1_plot(it+1)=mean(x1(1,:));
    x2_plot(it+1)=mean(x1(2,:));
    x3_plot(it+1)=mean(x1(3,:));
%
end
%
toc
%
iteration=1:(it_max+1);
figure(1); hold on;
plot(iteration,x1_plot,'black')    % Figure 9.11b
plot(iteration,x1_ref,'--black')
%
figure(2); hold on;
plot(iteration,x2_plot,'black')    % Figure 9.11d
plot(iteration,x2_ref,'--black')
%
figure(3); hold on;
plot(iteration,x3_plot,'black')    % Figure 9.11f
plot(iteration,x3_ref,'--black')
%
