%                Fig9_2.m
%
%            Pattern search method by   Hookes & Jeeves
%                       (derivative-free method)
%             
%  Optimization of Rosenbrock function f(x1,x2)=100(x1^2-x2 )^2+(x1-1)^2 
%------------------------------------------------------------------------
%
%   routines called : constr.m
%                     explr.m
%                     func.m
%__________________________________________________________________________
clc;
close all;
clear all;
%
%
	N = 2;  % number of parameters (x1 & x2)
%-----------------------
    % initial particle 
	XBASE(1) = 0.5;	
	XBASE(2) = 0.5;	
%-----------------------
%
% step size for exploratory search
	STEP(1) = 10.0;
	STEP(2) = 10.0;
%	    
	ITRIAL = 0;
%    
% tolearnce used as a stopping criterion    
	TOL(1) =0.00001;
	TOL(2) = 0.00001;
%-----------------------------------------
%
%   bounds for x1 & x2
	XMAX(1) = 10;
	XMAX(2) = 10;	
	XMIN(1) = -10;
	XMIN(2) = -10;
%-----------------------------------------	
	ITER = 1;
%-----------------------------------------    
	TERM = 0;
%    
    XTEMP=XBASE;    
%    
	LC = 1;
%
EBASEn=[0 0];
%
[EBASEn]=constr(XTEMP,XMAX,XMIN,N);  % constraints to check the bounds of x1 & x2
                                                % at each iteration
%
XTEMP=EBASEn;
%
OPTIMI(ITER)=func(XTEMP)   % fitness function
%
IT=ITER;
Iters(1)=ITER;
%
  LC=0;
  it_max=200;  % maximum number of iterations
%
  while (ITER <it_max)
%   
    ITER=ITER+1
%  
  [EBASEo,ITERn]=explr(IT,XTEMP,STEP,XMAX,XMIN,N,LC);  % exploratory search
%  
ITERn=IT;
XTEMP=EBASEo;
ITER;
OPTIMI(ITER)=func(XTEMP)  % after an exploration    
%	
  YES = 0;
  for i = 1:N
 	if(XBASE(i)~= XTEMP(i));
 	    YES = 1;
    end
  end
%
%
if(YES==1)   % a successful exploration 
    YES;
    %
    % then go for a pattern search
	for i = 1:N
	   XPATN(i) = XTEMP(i) * 2 - XBASE(i);  % for pattern search
    end
%
    [EBASEn]=constr(XPATN,XMAX,XMIN,N)
    XPATN=EBASEn;
%    
IT=ITER;
     [EBASEo,ITERn]=explr(IT,XPATN,STEP,XMAX,XMIN,N,LC);
     XPATN=EBASEo;
%     
     STEP;
%
	FXTEMP = func(XTEMP);
	FXPATN = func(XPATN);
%
	if(FXPATN < FXTEMP)   % pattern search successful
         LC=1;
%
	   for i =1:N
     	XBASE(i) = XTEMP(i);
	    XTEMP(i) = XPATN(i);
       end       
% 
     OPTIMI(ITER)=func(XTEMP) ; % store after a successful pattern search
%   x1(ITER)=XTEMP(1);
%   x2(ITER)=XTEMP(2);
%  
    elseif(FXPATN >= FXTEMP)
        LC=2;
	   for i = 1:N
	   XBASE(i) = XTEMP(i);   % Pattern search NOT successful. go to next exploration
%       
       break
       end
%
    end
%
elseif(YES==0)  % exploration itself NOT successful
    YES;
		for  i =1:N
            ITER;
		   STEP(i) = 0.5*STEP(i) ; % for exploration again with reduced step
        end
%        
end
%
 Iters(ITER)=ITER;
  x1(ITER)=XTEMP(1);
  x2(ITER)=XTEMP(2);
 OPTMI(ITER)=func(XTEMP);
 
    end   
%plotting 
    figure(1)   % Figure 9.2
    plot(Iters,OPTIMI,'black')
%     figure(2)               % optional 
%     plot(Iters,x1,'black')
%     figure(3)               % optional
%     plot(Iters,x2,'black')



