%                               
%
%                              Figure 9.8
%
%                       Differential Evolution 
%
%                   Van der Pol oscillator


clear all; clc; close all;

global eta stif
eta = 4;
stif=10;

gen_max=200;
x1_ref(1:gen_max+1)=eta;
x2_ref(1:gen_max+1)=stif;

T=5.0;
dtt=0.01;
nTt=T/dtt+1;
tt=linspace(0,T,nTt)'; % time variables

[z]=vanderpol_states();
figure(5)
plot(tt,z(1,:)),hold on
% figure(6)
plot(tt,z(2,:))

Np=20;D=2;
npar=D;

varhi(1)=10;
varhi(2)=20;
varlo(1)=1;
varlo(2)=5;

for i=1:npar
    for j=1:Np
       par(i,j)=(varhi(i)-varlo(i))*rand+varlo(i) % random
    end
end

 x1_init=par;

x1=x1_init;
for i=1:Np
    cost(i)=fun_vanderpol(z,x1(:,i));
end

 x1_plot(1)=mean(x1(1,:),2);
 x2_plot(1)=mean(x1(2,:),2);

 cost_plot(1)=mean(cost);
 
count=0;CR=.9;
while count<gen_max
    count
    for i=1:Np
        r1=i;
        while r1==i
            r1=randi(Np);
        end
        r2=i;
        while (r2==r1 || r2==i)
            r2=randi(Np);
        end
        r3=i;
        while (r3==r1 || r3==r2 || r3==i)
            r3=randi(Np);
        end
        j=randi(D);
        for k=1:D
            if rand(1)<CR || k==D
                F=2*rand(1);
                trial(j,1)=x1(j,r1)+F*(x1(j,r2)-x1(j,r3));
            else
                trial(j,1)=x1(j,i);
            end
            j=j+1;
            if j>D
                j=D;
            end
        end
        
        score=fun_vanderpol(z,trial);
        if score<=cost(i)
            x2(:,i)=trial;
            cost(i)=score;
        else
            x2(:,i)=x1(:,i);
        end
    end
    x1=x2;
    count=count+1;
    cost_plot(count+1)=mean(cost);
    x1_plot(count+1)=mean(x1(1,:),2);
    x2_plot(count+1)=mean(x1(2,:),2);
      
end
x1
cost
iteration=1:(gen_max+1);
figure(1)
plot(iteration,x1_plot,'black'),hold on
plot(iteration,x1_ref,'--black')

figure(2)
plot(iteration,x2_plot,'black'),hold on
plot(iteration,x2_ref,'--black')

figure(4); hold on;
plot(iteration,cost_plot,'black')
